#include "scene.h"
#include "ppc.h"
#include "linesegment.h"
#include "triangle.h"
#include "tmesh.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 0;
  int v0 = 0;
  int w = 640;
  int h = 480;
  fb = new FrameBuffer(u0, v0, w, h);
  fb->label("Frame Buffer");
  fb->show();

  gui->uiw->position(fb->w+20, 40);

  tmesh = new TMesh();
  tmesh->Load("geometry/teapot1K.bin");
  tmesh->Scale(20.0f);
  tmesh->TranslateTo(V3(0.0f, 0.0f, -50.0f));

  float hfov = 55.0f;
  ppc = new PPC(hfov, w, h);

  Render();

}

void Scene::DBG() {

  int w = fb->w;
  int h = fb->h;
  float hfov = 25.0f;

  ppc->Tilt(-10.0f);

  PPC ppc2(hfov, w, h);
  ppc2.TranslateFB(50.0f);
  ppc2.TranslateUD(-10.0f);
  ppc2.Pan(30.0f);
  for (int i = 0; i < 360; i++) {
    ppc2.Pan(1.0f);
    fb->ClearBuffers();
    ppc2.Visualize(ppc, fb, 20.0f, 0xFF000000);
    fb->redraw();
    Fl::check();
  }

}

void Scene::Render() {

  fb->ClearBuffers();
 
  tmesh->RenderFilled(ppc, fb);
    
  fb->redraw();

}